
/*
 *          |          _                     _______________________
 *          |\       _/ \_                  |                       |
 *          | \_    /_    \_                |    Alexandre Botao    |
 *          \   \__/  \__   \               |     www.botao.org     |
 *           \_    \__/  \_  \              |    55-11-8244-UNIX    |
 *             \_   _/     \ |              |  alexandre@botao.org  |
 *               \_/        \|              |_______________________|
 *                           |
 */

/*                                       _______________________________
 *                                      |                               |
 *                                      |   vdt      visual disk test   |
 *                                      |_______________________________|
 */

/*______________________________________________________________________
 |                                                                      |
 |  This file is part of 'VDT' (the Visual Disk Test).                  |
 |                                                                      |
 |  'VDT' is free software: you can redistribute it and/or modify it	|
 |  under the terms of the GNU General Public License as published by	|
 |  the Free Software Foundation, either version 3 of the License, or	|
 |  (at your option) any later version.                                 |
 |                                                                      |
 |  'VDT' is distributed in the hope that it will be useful,            |
 |  but WITHOUT ANY WARRANTY; without even the implied warranty of      |
 |  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                |
 |  See the GNU General Public License for more details.                |
 |                                                                      |
 |  You should have received a copy of the GNU General Public License	|
 |  along with 'VDT'.  If not, see <http://www.gnu.org/licenses/>, or	|
 |  write to the Free Software Foundation, Inc.,                        |
 |  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.            |
 |______________________________________________________________________|
 */

# define	SWNAME			"vdt"
# define	SWVERS			"5.3.41"
# define	SWDATE			"2010/07/28"
# define	SWCOPY			"(fos)"
# define	SWAUTH			"alexandre@botao.org"

# include	"vdt.h"

/*	__	__	__	__	__	__	__	__	*/

char *		swid = BANNER ;

int		incrflag = 0 ;
int		decrflag = 0 ;
int		convflag = 0 ;
int		scatflag = 0 ;
int		goldflag = 0 ;
int		spotflag = 0 ;
int		randflag = 0 ;

VDTYPEINFO	vdaddrlist [] = {
	{ &incrflag , "incr" } ,
	{ &decrflag , "decr" } ,
	{ &convflag , "conv" } ,
	{ &scatflag , "scat" } ,
	{ &goldflag , "gold" } ,
	{ &spotflag , "spot" } ,
	{ &randflag , "rand" } ,
	{ NULL,		NULL }
} ;

int		headflag = 0 ;
int		coreflag = 0 ;
int		tailflag = 0 ;
int		edgeflag = 0 ;	/* edge or curb						*/
int		slabflag = 0 ;	/* edge + core						*/

VDTYPEINFO	vdarealist [] = {
	{ &headflag , "head" } ,
	{ &coreflag , "core" } ,
	{ &tailflag , "tail" } ,
#ifdef FULLAREAOPTS
	{ &edgeflag , "edge" } ,
	{ &slabflag , "slab" } ,
#endif
	{ NULL,		NULL }
} ;

int		averflag = 0 ;
int		blotflag = 0 ;
int		burnflag = 0 ;
int		compflag = 0 ;
int		copyflag = 0 ;
int		cookflag = 0 ;
int		coolflag = 0 ;
int		messflag = 0 ;
int		readflag = 0 ;
int		sectflag = 0 ;	/* single sector i/o				*/
int		seekflag = 0 ;	/* seek								*/
int		writflag = 0 ;

VDTYPEINFO	vdtestlist [] = {
	{ &averflag , "aver" } ,
	{ &blotflag , "blot" } ,
	{ &burnflag , "burn" } ,
	{ &compflag , "comp" } ,
	{ &cookflag , "cook" } ,
	{ &coolflag , "cool" } ,
	{ &copyflag , "copy" } ,
	{ &messflag , "mess" } ,
	{ &readflag , "read" } ,
	{ &sectflag , "sect" } ,
	{ &seekflag , "seek" } ,
	{ &writflag , "writ" } ,
	{ NULL,		NULL }
} ;

int		evenflag = 0 ;
int		flipflag = 0 ;
int		fullflag = 0 ;
int		syncflag = 0 ;
int		uniqflag = 0 ;
int		waitflag = 0 ;	/* "hit [Enter] to finish			*/

VDTYPEINFO	vdflaglist [] = {
	{ &evenflag , "even" } ,
	{ &flipflag , "flip" } ,
	{ &fullflag , "full" } ,
	{ &syncflag , "sync" } ,
	{ &uniqflag , "uniq" } ,
	{ &waitflag , "wait" } ,
	{ NULL,		NULL }
} ;

int		percflag = 0 ;
int		strpflag = 0 ;
int		helpflag = 0 ;

int		verbflag = 0 ;	/* undoc/ed : verbose log info		*/
int		fillflag = 0 ;	/* undoc/ed : rev.vid fill up %box	*/

int		skipcnt = 0 ;
int		stripcnt = 0 ;
int		stripinx = 0 ;
int		randhitp = 0 ;
int		randextr = 0 ;

# ifdef SLICADDR
int		serislicflag = 0 ;
int		distslicflag = 0 ;
# endif

int		delay = 2 ;
int		pass = 0 ;

int		wsrows = 0 ;
int		wscols = 0 ;

int		avrows = 0 ;
int		avcols = 0 ;

int		brow ;
int		bcol ;

int		warea = 0 ;
int		wdens = 0 ;

int		declperc = 0 ;
int		usedperc = 0 ;
int		percok, lastpercok ;
int		percy, lastpercy ;
int		pwprev ;

size_t	altbufsiz = 0 ;

off_t	visblkcnt = 0 ;			/* total logical blocks				*/
off_t	visblkrnd ;				/* logical block entropy			*/

long		visblksiz = 0 ;
long		visblksects = 0 ;
long		totvisblk ;
long		lastsize ;
long		sectsize = DFLSECSIZ ;

off_t		filesize = 0 ;
off_t		testsize = 0 ;
off_t		declsize = 0 ;
off_t		percsize = 0 ;
off_t		worksize = 0 ;
off_t		headsize = 0 ;
off_t		tailsize = 0 ;
off_t		corehead = 0 ;
off_t		coretail = 0 ;
off_t		moresize = 0 ; /* find a better name ! */
off_t		strparea = 0 ;
off_t		strpsize = 0 ;
off_t		skiparea = 0 ;
off_t		skipsize = 0 ;
off_t		strpbase [MAXSTRIPECNT] ;

char *		readfilename = NULL ;
char *		rwiofilename = NULL ;
char *		writfilename = NULL ;

char		pwpbuf [64] ;
char		errmsg [1024] ;

char		skipchar = '_' ;

FILE *		lfp = NULL ;

WINDOW *	mwp = NULL ;	/* main			*/
WINDOW *	bwp = NULL ;	/* visblk		*/
WINDOW *	swp = NULL ;	/* status		*/
WINDOW *	pwp = NULL ;	/* progress		*/
WINDOW *	xwp = NULL ;	/* extra		*/
WINDOW *	iwp = NULL ;	/* info			*/

VISBLKDAT *			lbp = NULL ;
VISBLKDAT *			visblklst = NULL ;

struct stat			sb ;
struct timeval		tod1 , tod2 ;
struct timeval		tod5 , tod6 ;
struct timeval		tod11 , tod12 ;
struct timeval		tod15 , tod16 ;
struct timezone		tzb ;

#ifdef AIX
struct devinfo devinfbuf ;
struct lv_info lv_infbuf ;
#endif

#ifdef HPUX
struct capacity capinfbuf ;
disk_describe_type dskdesbuf ;
capacity_type dskcapbuf ;
#endif

#ifdef SUNX
#	ifdef USE_MEDINF
struct dk_minfo medinfbuf ;
#	endif
#	ifdef USE_DSKGEO
struct dk_geom  dskgeobuf ;
#	endif
#endif

long long			diftim ;	/* usecs */

int					specindx = -1 ;

VDTMARK				vdtspec [] = {
	{ "open"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "close" , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "read"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "seek"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "stat"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "write" , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "blot"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "cool"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "copy"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "mess"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "aver"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "comp"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ "jump"  , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
	{ NULL    , LLONG_MAX , LLONG_MIN , 0 , 0 , 0 , { DOUBLE_MAX , DOUBLE_MIN , 0.0 , 0.0 } } ,
} ;

/*	__	__	__	__	__	__	__	__	*/

long lceilp2 (x) long x ; {

	long c ;

	if (x < 0)
		return -1 ;

	for ( c = 1 ; c < x ; c <<= 1 )
		;

	return c ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdterr () {
	FILE * efp = lfp ;
	if (efp == NULL)
		efp = stderr ;
	fprintf (stderr, "*** %s: %s\n", swid, errmsg) ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdtend (sig) int sig ; {

	signal (SIGINT, SIG_IGN) ;
	if ( mwp != NULL )
		endwin () ;
	if ( sig != 0 ) {
		if ( sig > 0 ) {
			sprintf (errmsg, "sig(%d)\n", sig) ;
		} else {
			sprintf (errmsg, "err(%d)\n", sig) ;
		}
		vdterr () ;
	}
	if (lfp != NULL)
		fclose (lfp) ;
	exit (sig) ;
}

/*	__	__	__	__	__	__	__	__	*/

void getwinsiz () {

	int rd , fd = 1 ;
	struct winsize wsb ;

	rd = ioctl (fd, TIOCGWINSZ, &wsb) ;

	if (rd < 0) {
		perror (swid) ;
		vdtend (-1) ;
	}

	wsrows = wsb.ws_row ;
	wscols = wsb.ws_col ;
}

/*	__	__	__	__	__	__	__	__	*/

void sigwinch (sig) int sig ; {

	signal (SIGINT, SIG_IGN) ;
	signal (SIGWINCH, SIG_IGN) ;

	move (3, 1) ;
	printw ("sig(%d)", sig) ;
	refresh () ;
	sleep (delay) ;

/*	getwinsiz () ;	*/

	endwin () ;
	vdtinit () ;
}

/*	__	__	__	__	__	__	__	__	*/

void setaltsecsiz ( altsiz ) int altsiz ; {

	if ( altsiz != sectsize )
		sectsize = altsiz ;
}

/*	__	__	__	__	__	__	__	__	*/

void usage () {

	fprintf (stderr, "Usage : %s <options> <parameters>\n", swid) ;
	fprintf (stderr, "Perform i/o tests.\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "basic parameters:\n") ;
    fprintf (stderr, "\n") ;
	fprintf (stderr, " -b size       alternate i/o buffer size\n") ;
	fprintf (stderr, " -f filename   use this file for read/write tests\n") ;
	fprintf (stderr, " -p percent    test area = given %% of testsize\n") ;
	fprintf (stderr, " -r filename   use this input file for read-only tests\n") ;
	fprintf (stderr, " -s stripes    split test area in given # of stripes\n") ;
	fprintf (stderr, " -w filename   use this output file for write-only tests\n") ;
	fprintf (stderr, " -z testsize   test area = just this much (default=whole file)\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "basic tests:\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, " --read        read test (Bunch_of_Sectors at a time)\n") ;
    fprintf (stderr, " --sect        i/o just a single (512-Byte) sector at a time\n") ;
    fprintf (stderr, " --seek        seek test (same as '--read --sect')\n") ;
    fprintf (stderr, " --writ        write test (B.o.S. at a time)\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "compound tests:\n") ;
    fprintf (stderr, "\n") ;
	fprintf (stderr, " --aver        ratify test (write, read back, compare)\n") ;
    fprintf (stderr, " --blot        update test (read, stain, write back)\n") ;
    fprintf (stderr, " --comp        comparison test (B.o.S. at a time)\n") ;
	fprintf (stderr, " --cool        freshen test (read, write back)\n") ;
    fprintf (stderr, " --copy        copy test (B.o.S. at a time)\n") ;
	fprintf (stderr, " --mess        shuffle test (read, write somewhere else)\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "stress tests:\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, " --burn        burn (read/write) test (all addressing modes)\n") ;
    fprintf (stderr, " --cook        cook (read-only)  test (all addressing modes)\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "address patterns:\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, " --incr        incrementing addresses (start to end)\n") ;
    fprintf (stderr, " --decr        decrementing addresses (end to start)\n") ;
    fprintf (stderr, " --conv        converging addresses (edges to middle)\n") ;
    fprintf (stderr, " --scat        scattering addresses (middle to edges)\n") ;
    fprintf (stderr, " --gold        'diamond'-pattern (middle to edges and back)\n") ;
    fprintf (stderr, " --spot        'X'-pattern (edges to middle and back)\n") ;
    fprintf (stderr, " --rand        random addresses\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "region location:\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, " --edge        --head and --tail combined\n") ;
    fprintf (stderr, " --head        select initial portion of test area (default)\n") ;
    fprintf (stderr, " --core        select central portion of test area\n") ;
    fprintf (stderr, " --tail        select  final  portion of test area\n") ;
    fprintf (stderr, " --slab        --edge and --core combined\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "operation flags:\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, " --even        divide test area proportionally\n") ;
    fprintf (stderr, " --flip        invert selection of test area\n") ;
    fprintf (stderr, " --full        random seek within B.o.S.\n") ;
    fprintf (stderr, " --help        show this usage help\n") ;
    fprintf (stderr, " --once        same as --uniq\n") ;
    fprintf (stderr, " --sync        synchronous (blocking) output\n") ;
    fprintf (stderr, " --uniq        test each and every random address just once\n") ;
    fprintf (stderr, " --wait        request user interaction to finish\n") ;
    fprintf (stderr, "\n") ;
    fprintf (stderr, "extra parameters:\n") ;
    fprintf (stderr, "\n") ;
	fprintf (stderr, " -l lines      override screen's # of lines\n") ;
	fprintf (stderr, " -c columns    ditto for columns\n") ;
    fprintf (stderr, "\n") ;

	exit (1) ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdtinit () {

	int	rd ;
	char *	osnam ;
	struct utsname utsbuf ;

	rd = uname ( &utsbuf ) ;

	osnam = ( rd == -1 ) ? "unknown" : utsbuf.sysname ;

	printf ("\n%s %s %s %s %s %s\n\n", BANNER, SWVERS, osnam, SWDATE, SWCOPY, SWAUTH) ;

	if ( helpflag )
		usage () ;

	if ( readfilename == NULL && writfilename == NULL ) {
		fprintf (stderr, "*** no filename informed.\n") ;
		fprintf (stderr, "==> try `vdt --help' for details.\n\n") ;
		vdtend (0) ;
	}

	if ( altbufsiz != 0 ) {
		if ( altbufsiz % sectsize ) {
			fprintf (stderr, "*** alternate buffer size must be a multiple of %d.\n", (int)sectsize) ;
			vdtend (-66) ;
		}
	}

	if ( seekflag ) {
		++readflag ;
		++sectflag ;
	}

	if ( copyflag ) {
		if ( readfilename == NULL || writfilename == NULL ) {
			fprintf (stderr, "*** missing input or output filename.\n") ;
			vdtend (-111) ;
		}
		++readflag ;
		++writflag ;
		if ( ! ( incrflag || decrflag || convflag || scatflag || spotflag || goldflag || randflag ) ) {
			++incrflag ;
		}
	}

	if ( percflag && evenflag ) {
		fprintf (stderr, "*** --even and --perc are mutually exclusive\n") ;
		vdtend (-144) ;
	}

	if ( cookflag ) {
		readflag = incrflag = decrflag = convflag = scatflag = spotflag = goldflag = randflag = 1 ;
	}

	if ( strpflag ) {
		if ( ! ( percflag || evenflag ) ) {
			fprintf (stderr, "*** '-s #' requires '-p %%' or --even\n") ;
			vdtend (-155) ;
		}
		if ( stripcnt < MINSTRIPECNT || stripcnt > MAXSTRIPECNT ) {
			fprintf (stderr, "*** stripe count out of range (%d..%d)\n", MINSTRIPECNT, MAXSTRIPECNT) ;
			vdtend (-166) ;
		}
		if ( headflag || tailflag || coreflag || edgeflag || slabflag ) {
			fprintf (stderr, "*** '-s #' and head/core/tail are mutually exclusive\n") ;
			vdtend (-177) ;
		}
	}

	if ( slabflag ) {
		++edgeflag ;
		++coreflag ;
	}

	if ( edgeflag ) {
		++headflag ;
		++tailflag ;
	}

	if ( percflag ) {
		if ( declperc < 1 || declperc > 100 ) {
			fprintf (stderr, "*** percent out of range (%d..%d)\n", 1, 100) ;
			vdtend (-188) ;
		}
		usedperc = declperc ;
		if ( ! ( headflag || tailflag || coreflag || edgeflag || slabflag || strpflag ) ) {
			++headflag ;
		}
	}

	if ( sectflag ) {
		specindx = SPECTABXSEEK ;
	} else {
		if ( readflag ) {
			specindx = SPECTABXREAD ;
		}
	}

	if ( fullflag ) {
		if ( ! sectflag ) {
			++uniqflag ;
			fullflag = 0 ;
		}
	}

	if ( uniqflag || fullflag )
		++randflag ;

	getwinsiz () ;

	mwp = initscr () ;

	if (mwp == NULL) {
		fprintf (stderr, "%s: initscr failed\n", swid) ;
		vdtend (-144) ;
	}

	if ( avrows == 0 ) {
		if ( wsrows > 0 ) {
			avrows = (int) pow((double)2,floor(log2((double)(wsrows-8)))) ;
		} else {
			avrows = DFLAVROWS ;
		}
	}

	if ( avcols == 0 ) {
		if ( wscols > 0 ) {
			avcols = (int) pow((double)2,floor(log2((double)(wscols-16)))) ;
		} else {
			avcols = DFLAVCOLS ;
		}
	}

	lfp = fopen (VDTLOG, "w") ;

	signal (SIGINT, vdtend) ;
	signal (SIGWINCH, sigwinch) ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdtreps (inx, lfp) int inx ; FILE * lfp ; {

	VDTMARK * tip ;
	char * nam ;

	tip = vdtspec + inx ;
	nam = tip->vdm_nam ;

	fprintf (lfp, "%scount=%ld ",  nam, tip->vdm_cnt) ;
	fprintf (lfp, "tot%stime=%lld.%06llds ",  nam, tip->vdm_sum / 1000000, tip->vdm_sum % 1000000 ) ;
	fprintf (lfp, "min%stime=%fs ",  nam, (double) (tip->vdm_min / 1000000.0)	) ;
	fprintf (lfp, "avg%stime=%fs ",  nam, (double) (tip->vdm_avg / 1000000.0)	) ;
	fprintf (lfp, "max%stime=%fs ",  nam, (double) (tip->vdm_max / 1000000.0)	) ;
	if ( ! sectflag ) {
		if ( inx != SPECTABXSEEK && inx != SPECTABXJUMP ) {
# ifdef RAWSPEED
			fprintf (lfp, "min%sperf=%f/s ", nam, (double) (1000000.0 * tip->vdm_prf.vdp_min)	) ;
			fprintf (lfp, "avg%sperf=%f/s ", nam, (double) (1000000.0 * tip->vdm_prf.vdp_avg)	) ;
			fprintf (lfp, "max%sperf=%f/s ", nam, (double) (1000000.0 * tip->vdm_prf.vdp_max)	) ;
# else
			fprintf (lfp, "min%sperf=%s/s ", nam, lltokmgtpe ( (long long) (1000000.0 * tip->vdm_prf.vdp_min)	) ) ;
			fprintf (lfp, "avg%sperf=%s/s ", nam, lltokmgtpe ( (long long) (1000000.0 * tip->vdm_prf.vdp_avg)	) ) ;
			fprintf (lfp, "max%sperf=%s/s ", nam, lltokmgtpe ( (long long) (1000000.0 * tip->vdm_prf.vdp_max)	) ) ;
# endif
		}
	}
	tip->vdm_min = LLONG_MAX ;
	tip->vdm_max = LLONG_MIN ;
	tip->vdm_avg = tip->vdm_sum = tip->vdm_cnt = 0 ;
	tip->vdm_prf.vdp_min = DOUBLE_MAX ;
	tip->vdm_prf.vdp_max = DOUBLE_MIN ;
	tip->vdm_prf.vdp_avg = tip->vdm_prf.vdp_sum = 0.0 ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdtacct (inx, tv1, tv2, siz) int inx ; struct timeval * tv1 , * tv2 ; long siz ; {

	VDTMARK *	tip ;
	double		dbltim , dblsiz , dbltpt ;

	diftim = diftod ( tv1 , tv2 ) ;

	if ( diftim == 0 )
		diftim = 1 ;

	tip = vdtspec + inx ;

	tip->vdm_sum += diftim ;
	tip->vdm_cnt += 1 ;
	tip->vdm_avg = tip->vdm_sum / tip->vdm_cnt ;

	if ( diftim < tip->vdm_min )
		tip->vdm_min = diftim ;

	if ( diftim > tip->vdm_max )
		tip->vdm_max = diftim ;

	if ( siz == -1L )
		return ;

	if ( siz == visblksiz ) {
		dbltim = diftim ;
		dblsiz = siz ;
		dbltpt = dblsiz / dbltim ;		/* bytes / usec */
		tip->vdm_prf.vdp_sum += dbltpt ;
		tip->vdm_prf.vdp_avg = tip->vdm_prf.vdp_sum / tip->vdm_cnt ;
		if ( dbltpt < tip->vdm_prf.vdp_min )
			tip->vdm_prf.vdp_min = dbltpt ;
		if ( dbltpt > tip->vdm_prf.vdp_max )
			tip->vdm_prf.vdp_max = dbltpt ;
	}
}

# ifdef SLICADDR

/*	__	__	__	__	__	__	__	__	*/

off_t nextserislicaddr (cur, tot) int cur , tot ; {

	return (off_t) cur + tot ;
}

off_t nextdistslicaddr (cur, tot) int cur , tot ; {

	return (off_t) cur + tot ;
}

# endif

/*	__	__	__	__	__	__	__	__	*/

# ifdef ORIG
char * getvdaddr () {
	int i ;
	for ( i = 0 ; vdaddrlist[i].vty_name != NULL ; ++i )
		if ( *(vdaddrlist[i].vty_flag) )
			return vdaddrlist[i].vty_name ;
	return "none" ;
}
# else
char * getvdaddr (adr) int adr ; {
	static char * ap ;
	switch ( adr ) {
		case VDT_INCR : ap = "incr" ; break ;
		case VDT_DECR : ap = "decr" ; break ;
		case VDT_SCAT : ap = "scat" ; break ;
		case VDT_CONV : ap = "conv" ; break ;
		case VDT_SPOT : ap = "spot" ; break ;
		case VDT_GOLD : ap = "gold" ; break ;
		case VDT_RAND : ap = "rand" ; break ;
		default : ap = "none" ; break ;
	}
	return ap ;
}
# endif

/*	__	__	__	__	__	__	__	__	*/

char * getvdarea () {
	int i ;
	static char abuf [80] ;
	for ( abuf[0] = i = 0 ; vdarealist[i].vty_name != NULL ; ++i )
		if ( *(vdarealist[i].vty_flag) ) {
			strcat ( abuf , vdarealist[i].vty_name ) ;
			strcat ( abuf , "," ) ;
		}
	abuf[strlen(abuf)-1] = '\0' ;
	return abuf ;
}

/*	__	__	__	__	__	__	__	__	*/

char * getvdtest () {
	int i ;
	static char tbuf [80] ;
	for ( tbuf[0] = i = 0 ; vdtestlist[i].vty_name != NULL ; ++i )
		if ( *(vdtestlist[i].vty_flag) ) {
			strcat ( tbuf , vdtestlist[i].vty_name ) ;
			strcat ( tbuf , "," ) ;
		}
	tbuf[strlen(tbuf)-1] = '\0' ;
	return tbuf ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdtstats (inx, adr) int inx , adr ; {

	fprintf (lfp, "%s=%s ", BANNER, SWVERS) ;
	fprintf (lfp, "test=%s ", getvdtest()) ;
	fprintf (lfp, "addr=%s ", getvdaddr(adr)) ;
	if ( readfilename != NULL )
		fprintf (lfp, "input=%s ", readfilename) ;
	if ( writfilename != NULL )
		fprintf (lfp, "output=%s ", writfilename) ;
	fprintf (lfp, "size=%lld ", (long long) filesize) ;

#ifdef SUNX
#	ifdef USE_MEDINF
		fprintf (lfp, "capac=%lld visblksiz=%lld ", (long long)medinfbuf.dki_capacity, (long long)medinfbuf.dki_visblksiz);
#	endif
#	ifdef USE_DSKGEO
		fprintf (lfp, "cyls=%lld heads=%lld sects=%lld ", (long long)dskgeobuf.dkg_ncyl, (long long)dskgeobuf.dkg_nhead, (long long)dskgeobuf.dkg_nsect);
#	endif
#endif

	if ( filesize != testsize )
		fprintf (lfp, "used=%lld ", (long long) testsize) ;

	if ( percflag ) {
		if ( evenflag )
			fprintf (lfp, "even=%lld ", (long long) ( flipflag ? 100 - usedperc : usedperc ) ) ;
		else
			fprintf (lfp, "percent=%lld ", (long long) ( flipflag ? 100 - usedperc : usedperc ) ) ;
	}

	if ( strpflag ) {
		if ( flipflag )
			fprintf (lfp, "stripes=%lldx%lld ", (long long) skipcnt , (long long) skipsize) ;
		else
			fprintf (lfp, "stripes=%lldx%lld ", (long long) stripcnt , (long long) strpsize) ;
	}

	if ( headflag || tailflag || coreflag || edgeflag || slabflag )
		fprintf (lfp, "region=%s ", getvdarea()) ;

	fprintf (lfp, "blocks=%lldx%lld", (long long) totvisblk, (long long) visblksiz) ;

	if (lastsize > 0)
		fprintf (lfp, "+%lld", (long long) lastsize) ;

	fprintf (lfp, " ") ;

	if ( altbufsiz != 0 )
		fprintf (lfp, "altbufsiz=%d ", (int)altbufsiz) ;

	vdtreps (inx, lfp) ;

	if ( verbflag ) {
		fprintf (lfp, "screen=%dx%d ", wsrows, wscols) ;
		fprintf (lfp, "window=%dx%d ", avrows, avcols) ;
		fprintf (lfp, "area=%d ", warea) ;
		fprintf (lfp, "dens=%d ", wdens) ;
	}

	if ( randflag ) {
		if ( randhitp ) {
			fprintf (lfp, "(%d %% rand cache hit) ", randhitp) ;
		}
		if ( uniqflag ) {
			fprintf (lfp, "(%d rand extra) ", randextr) ;
		}
	}

	if (copyflag) {
		switch ( inx ) {
			case SPECTABXREAD : vdtreps (SPECTABXSEEK, lfp) ; break ;
			case SPECTABXWRIT : vdtreps (SPECTABXJUMP, lfp) ; break ;
		}
	} else {
		if ( ! sectflag ) {
			vdtreps (SPECTABXSEEK, lfp) ;
		}
	}

	fprintf (lfp, "\n") ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdtest (addrmode) int addrmode ; {

	VFD rfd = -1 , wfd = -1 ;
	VDTMARK * tip = vdtspec + specindx ;
	int i , rd , xtroutbit = 0 , hits = 0 , hitp , hito = 0 ;
	char * readbuff = NULL ;
	char * writbuff = NULL ;
	off_t ofs ;
	size_t readsize ;
	size_t writsize ;

	if (readflag) {
		readbuff = malloc (visblksiz) ;

		if (readbuff == NULL) {
			perror ("input buffer") ;
			vdtend (errno) ;
		}

		rfd = VOPEN (readfilename, MODEIN, 0) ;

		if ( rfd < 0 ) {
			perror (readfilename) ;
			vdtend (errno) ;
		}
	}

	if (writflag) {
		if (copyflag)
			writbuff = readbuff ;
		else
			writbuff = malloc (visblksiz) ;

		if (writbuff == NULL) {
			perror ("output buffer") ;
			vdtend (errno) ;
		}

		if ( syncflag )
			xtroutbit = O_SYNC ;

		if ( access ( writfilename , F_OK ) == 0 )
			wfd = VOPEN (writfilename, MODEOUT|xtroutbit, 0) ;
		else
			wfd = VOPEN (writfilename, MODEZAP|xtroutbit, S_IRWXU) ;

		if ( wfd < 0 ) {
			perror (writfilename) ;
			vdtend (errno) ;
		}
	}

	if (copyflag)
		mvwaddstr (iwp, 1, 1, "copy") ;
	else
		mvwaddstr (iwp, 1, 1, sectflag ? "seek" : "read") ;
	mvwaddstr (iwp, 1, 7, getvdaddr(addrmode)) ;
	mvwaddstr (iwp, 2, 1, "         ") ;
	if ( randflag ) {
		if ( fullflag )
			mvwaddstr (iwp, 2, 1, "full") ;
		if ( uniqflag )
			mvwaddstr (iwp, 2, 7, "uniq") ;
	}
	wrefresh (iwp) ;

	lastpercok = -1 ;
	for ( i = 0 ; (i < visblkcnt) || ( uniqflag && (hits < visblkcnt) ) ; ++i ) {

		if ( hito >= visblkcnt )
			break ;

		switch ( addrmode ) {
			case VDT_INCR : lbp = visblklst + i ;	/* NEXTINCRADDR */ break ;
			case VDT_DECR : lbp = visblklst + NEXTDECRADDR (i, visblkcnt) ; break ;
			case VDT_SCAT : lbp = visblklst + NEXTSCATADDR (i, visblkcnt) ; break ;
			case VDT_CONV : lbp = visblklst + NEXTCONVADDR (i, visblkcnt) ; break ;
			case VDT_SPOT : lbp = visblklst + NEXTSPOTADDR (i, visblkcnt) ; break ;
			case VDT_GOLD : lbp = visblklst + NEXTGOLDADDR (i, visblkcnt) ; break ;
			case VDT_RAND : lbp = visblklst + NEXTRANDADDR (i, visblkcnt) ; break ;
# ifdef SLICADDR
			else if ( serislicflag ) lbp = visblklst + NEXTSERISLICADDR (i, visblkcnt) ;
			else if ( distslicflag ) lbp = visblklst + NEXTDISTSLICADDR (i, visblkcnt) ;
# endif
			default : lbp = visblklst + i ; /* NEXTINCRADDR */ break ;
		}

		if ( ! ( lbp->vbd_flags & VBF_USEFUL ) )
			goto rdpct ;

		if ( uniqflag && ( lbp->vbd_flags & VBF_READOK ) ) {
			goto rdpct ;
		}

		if ( randflag && ( lbp->vbd_flags & VBF_READOK ) ) {
			if ( uniqflag && (lbp->vbd_hits == 1) ) {
				goto rdpct ;
			}
			++hits ;
			lbp->vbd_hits += 1 ;
			mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, (lbp->vbd_hits >= 10) ? '*' : '0' + (lbp->vbd_hits % 10)) ;
			wrefresh (bwp) ;
			goto rdpct ;
		}

		visblkrnd = 0 ;
		if ( fullflag && visblksects ) {
			visblkrnd = rand() % visblksects ;
		}

		if ( readflag ) {
			if ( sectflag ) {
				ofs = VSEEK (rfd, visblkrnd + lbp->vbd_addr, SEEK_SET) ;
			} else {
				gettimeofday (&tod5, &tzb) ;
				ofs = VSEEK (rfd, visblkrnd + lbp->vbd_addr, SEEK_SET) ;
				gettimeofday (&tod6, &tzb) ;
				vdtacct (SPECTABXSEEK, &tod5, &tod6, -1L) ;
			}
			if (ofs == (off_t) -1) {
				mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'S') ;
				wrefresh (bwp) ;
				goto rdpct ;
			}
			lbp->vbd_flags |= VBF_SEEKOK ;
		}

		if ( writflag ) {
			if ( sectflag ) {
				ofs = VSEEK (wfd, visblkrnd + lbp->vbd_addr, SEEK_SET) ;
			} else {
				gettimeofday (&tod15, &tzb) ;
				ofs = VSEEK (wfd, visblkrnd + lbp->vbd_addr, SEEK_SET) ;
				gettimeofday (&tod16, &tzb) ;
				vdtacct (SPECTABXJUMP, &tod15, &tod16, -1L) ;
			}
			if (ofs == (off_t) -1) {
				mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'J') ;
				wrefresh (bwp) ;
				goto rdpct ;
			}
			lbp->vbd_flags |= VBF_JUMPOK ;
		}

		if (readflag) {
			if ( sectflag )
				readsize = (size_t)sectsize ;
			else
				readsize = lbp->vbd_size ;
			if ( altbufsiz != 0 )
				readsize = altbufsiz ;
			gettimeofday (&tod1, &tzb) ;
			rd = VREAD (readbuff, 1, readsize, rfd) ;
			gettimeofday (&tod2, &tzb) ;
			vdtacct (copyflag ? SPECTABXREAD : specindx, &tod1, &tod2, (long)readsize) ;
			if (rd < 0) {
				mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'R') ;
				wrefresh (bwp) ;
				goto rdpct ;
			}
			if ((size_t)rd != readsize) {
				mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'Z') ;
				wrefresh (bwp) ;
				goto rdpct ;
			}
			lbp->vbd_flags |= VBF_READOK ;
		}

		if (writflag) {
			if ( sectflag )
				writsize = sectsize ;
			else
				writsize = lbp->vbd_size ;
			gettimeofday (&tod11, &tzb) ;
			rd = VWRITE (writbuff, 1, writsize, wfd) ;
			gettimeofday (&tod12, &tzb) ;
			vdtacct (SPECTABXWRIT, &tod11, &tod12, (long)writsize) ;
			if (rd < 0) {
				mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'W') ;
				wrefresh (bwp) ;
				goto rdpct ;
			}
			if ((size_t)rd != writsize) {
				mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'Z') ;
				wrefresh (bwp) ;
				goto rdpct ;
			}
			lbp->vbd_flags |= VBF_WRITOK ;
			if (copyflag) { /* FIXME: should be compound(acctREAD,acctWRIT) */
				vdtacct ( SPECTABXCOPY, &tod1, &tod12, (long)writsize /* + readsize */ ) ;
			}
		}

		mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, 'o') ;
		wrefresh (bwp) ;
		++hito ;
rdpct :
		if ( i >= visblkcnt )
			continue ;

		percok = ( (i+1) * 100 ) / visblkcnt ;
		if ( percok != lastpercok ) {
			percy = percok % 10 ? 1+(percok/10) : (percok/10) ;
			if ( percy ) {
				sprintf ( pwpbuf, "%3d %% %s", percok, (char *) lltokmgtpe ( (long long) (i+1) * (long long) visblksiz ) ) ;
				pwprev = ( percok % 10 ) ;
				if ( pwprev || ( ! fillflag ) ) {
					wstandout (pwp) ;
					mvwaddnstr (pwp, 11-percy, 1, pwpbuf, pwprev) ;
					wstandend (pwp) ;
					waddstr (pwp, pwpbuf+pwprev) ;
				} else {
					wstandout (pwp) ;
					mvwaddstr (pwp, 11-percy, 1, pwpbuf) ;
					wstandend (pwp) ;
				}
				wrefresh (pwp) ;
				lastpercok = percok ;
			}
			if (copyflag) {
				mvwprintw ( xwp, 2, 5, "%s/s", lltokmgtpe ( (long long) (1000000.0 * vdtspec[SPECTABXREAD].vdm_prf.vdp_avg) ) ) ;
				mvwprintw ( xwp, 3, 5, "%s/s", lltokmgtpe ( (long long) (1000000.0 * vdtspec[SPECTABXWRIT].vdm_prf.vdp_avg) ) ) ;
				mvwprintw ( xwp, 4, 5, "%s/s", lltokmgtpe ( (long long) (1000000.0 * vdtspec[SPECTABXCOPY].vdm_prf.vdp_avg) ) ) ;
			} else {
				mvwprintw ( xwp, 2, 1, "%10.6f", (double) (tip->vdm_avg / 1000000.0) ) ;
				if ( ! sectflag )
					mvwprintw ( xwp, 4, 5, "%s/s", lltokmgtpe ( (long long) (1000000.0 * tip->vdm_prf.vdp_avg) ) ) ;
			}
			wrefresh (xwp) ;
		}
	}

	/* random cache hits */

	if ( randflag ) {
		randhitp = hitp = ( hits * 100 ) / visblkcnt ;
		if ( uniqflag )
			randextr = (i-visblkcnt) ;
	}

	if (readflag) {
		VCLOSE (rfd) ;
		if ( readbuff != NULL )
			free (readbuff) ;
	}
	if (writflag) {
		VCLOSE (wfd) ;
		if ( ! copyflag )
			free (writbuff) ;
	}
	if (copyflag) {
		vdtstats ( SPECTABXREAD , addrmode ) ;
		vdtstats ( SPECTABXWRIT , addrmode ) ;
		vdtstats ( SPECTABXCOPY , addrmode ) ;
	} else {
		vdtstats ( specindx , addrmode ) ;
	}

	if ( waitflag ) {
		mvwaddstr (iwp, 1, 1, " Hit      ") ;
		mvwaddstr (iwp, 2, 1, "[Enter]   ") ;
		wrefresh (iwp) ;
		wmove (iwp, 2, 9) ;
		wgetch (iwp) ;
	}

	for ( i = 0 ; i < visblkcnt ; ++i ) {	/* repaint */
# ifdef ORIG
		if ( ( mvwinch (bwp, (visblklst+i)->vbd_lin, (visblklst+i)->vbd_col) & A_CHARTEXT ) != (chtype) skipchar ) {
# else
		if ( (visblklst+i)->vbd_flags & VBF_USEFUL ) {
# endif
			mvwaddch (bwp, (visblklst+i)->vbd_lin, (visblklst+i)->vbd_col, '.') ;
			(visblklst+i)->vbd_hits = 0 ;
			(visblklst+i)->vbd_flags &= ~(VBF_READOK | VBF_SEEKOK) ;
		}
	}
	wrefresh (bwp) ;
	/* sleep (1) ; */
}

/*	__	__	__	__	__	__	__	__	*/

void vdtmain () {

	int rd ;

	clear () ;

	border (0, 0, 0, 0, 0, 0, 0, 0) ;

	mvaddstr (0, 3, BANNER) ;
	mvaddstr (0, 6, SWVERS) ;

	refresh () ;

	rd = VSTAT (readfilename, &sb) ;

	if ( rd != 0 ) {
		fprintf (stderr, "*** error checking status of input file '%s'\n", readfilename) ;
		vdtend (-122) ;
	}

	/* FIXME: check output file if --writ */

	if ( S_ISCHR (sb.st_mode) || S_ISBLK (sb.st_mode) ) {
		if ( ( rd = open (readfilename, O_RDONLY) ) < 0 )
			vdtend (errno) ;
#ifdef AIX
		if ( ioctl (rd, IOCINFO, &devinfbuf) < 0 )
			vdtend (errno) ;
		switch (devinfbuf.devtype) {
			case DD_DISK:
				filesize = (off_t)devinfbuf.un.dk.segment_size * devinfbuf.un.dk.segment_count;
			break;
			case DD_SCDISK: /* scsi */
				filesize = (off_t)devinfbuf.un.scdk.blksize * devinfbuf.un.scdk.numblks;
			break;
			default:
				filesize = 0;
			break;
		}   
		if ( filesize == 0 && ( devinfbuf.devsubtype == DS_LV || devinfbuf.devsubtype == DS_LVZ ) ) {
			if ( ioctl (rd, LV_INFO, &lv_infbuf) < 0 )
				vdtend (errno) ;
			filesize = (off_t)sectsize * lv_infbuf.num_blocks;
		}
#endif
#ifdef HPUX
		if ( ioctl (rd, SIOC_CAPACITY, &capinfbuf) < 0 ) {
			if ( ioctl (rd, DIOC_CAPACITY, &dskcapbuf) < 0 ) {
				vdtend (errno) ;
			} else {
				if ( ioctl (rd, DIOC_DESCRIBE, &dskdesbuf) < 0 ) {
					vdtend (errno) ;
				} else {
					filesize = (off_t)dskdesbuf.lgblksz * (off_t)dskcapbuf.lba ;
					setaltsecsiz ( (int)dskdesbuf.lgblksz ) ;
				}
			}
		} else {
			filesize = (off_t)capinfbuf.lba * capinfbuf.blksz ;
			setaltsecsiz ( (int)capinfbuf.blksz ) ;
		}
#endif
#ifdef LINUX
		if ( ioctl (rd, BLKGETSIZE, &filesize) < 0 )
			vdtend (errno) ;
		filesize *= DFLSECSIZ ;
#endif
#ifdef FREEBSD
		if ( ioctl (rd, DIOCGMEDIASIZE, &filesize) < 0 )
			vdtend (errno) ;
#endif
#ifdef SUNX
#	ifdef USE_MEDINF
		if ( ioctl (rd, DKIOCGMEDIAINFO, &medinfbuf) < 0 )
			vdtend (errno) ;
		/* fprintf(stderr,"cap(%lld)visblkcnt(%lld)\r\n",(long long)medinfbuf.dki_capacity,(long long)medinfbuf.dki_visblksiz); */
		filesize = (off_t)medinfbuf.dki_capacity * medinfbuf.dki_visblksiz ;
#	endif
#	ifdef USE_DSKGEO
		if ( ioctl (rd, DKIOCGGEOM, &dskgeobuf) < 0 )
			vdtend (errno) ;
		/* fprintf(stderr,"cyl(%lld)hds(%lld)sec(%lld)\r\n",(long long)dskgeobuf.dkg_ncyl,(long long)dskgeobuf.dkg_nhead,(long long)dskgeobuf.dkg_nsect); */
		filesize = (off_t)dskgeobuf.dkg_ncyl * dskgeobuf.dkg_nhead * dskgeobuf.dkg_nsect * DFLSECSIZ ;
#	endif
#endif
		close (rd) ;
	} else {
		filesize = sb.st_size ;
	}

	if (declsize == 0)
		testsize = filesize ;
	else
		testsize = declsize ;

	if ( testsize <= 0 ) {
		fprintf (stderr, "*** invalid test size (%lld)\n", (long long)testsize) ;
		vdtend (-133) ;
	}

	if ( strpflag ) {
		skipcnt = stripcnt - 1 ;
	}

	if ( evenflag ) {
		++percflag ;
		if ( strpflag ) {
			declperc = ( 100 / ( stripcnt + skipcnt ) ) * stripcnt ;
		} else {
			if ( slabflag ) {
				declperc = 60 ;
			} else {
				if ( edgeflag ) {
					if ( coreflag ) {
						++slabflag ;
						declperc = 60 ;
					} else {
						declperc = 66 ;
					}
				} else {
					if ( coreflag ) {
						if ( headflag || tailflag ) {
							if ( headflag && tailflag ) {
								++edgeflag ;
								declperc = 60 ;
							} else {
								declperc = 66 ;
							}
						} else {
							declperc = 33 ;
						}
					} else {
						if ( headflag && tailflag ) {
							++edgeflag ;
							declperc = 66 ;
						} else {
							if ( headflag || tailflag ) {
								declperc = 50 ;
							}
						}
					}
				}
			}
		}
		usedperc = declperc ;
	}

	if ( percflag ) {
		if ( edgeflag ) {
			if ( coreflag ) {
				if ( declperc < 3 ) {
					declperc = 3 ;
					usedperc = declperc ;
				}
				declperc /= 3 ;
			} else {
				if ( declperc & 0x01 ) {
					if ( declperc == 1 ) {
						++declperc ;
					} else {
						--declperc ;
					}
					usedperc = declperc ;
				}
				declperc /= 2 ;
			}
		}
		percsize = ( testsize * declperc ) / 100 ;
		if ( headflag ) {
			headsize = percsize ;
		}
		if ( tailflag ) {
			tailsize = testsize - percsize ;
		}
		if ( coreflag ) {
			corehead = ( testsize - percsize ) / 2 ;
			coretail = corehead + percsize ;
		}
	}

	if ( strpflag ) {
		strparea = percsize ;
		skiparea = testsize - strparea ;
		strpsize = strparea / stripcnt ;
		skipsize = skiparea / skipcnt ;
		for ( stripinx = 0 ; stripinx < stripcnt ; ++stripinx ) {
			strpbase[stripinx] = stripinx * ( strpsize + skipsize ) ;
		}
	}

	warea = avrows * avcols ;

	if ( ( testsize % warea ) == 0 )
		wdens = testsize / warea ;
	else
		wdens = testsize / ( warea - 1 ) ;

	visblksiz = wdens ;

	if ( visblksiz < MINVISBLKSIZ ) {
		visblksiz = MINVISBLKSIZ ;
		visblksects = 0 ;
	} else {
		visblksiz = lceilp2 (visblksiz) ;
		visblksects = visblksiz / sectsize ;
	}

/*	bwp = newwin (18, 66, 1, 1) ;	*/
	bwp = newwin (BW_HEI, BW_WID, BW_LIN, BW_COL) ;
	wborder (bwp, 0, 0, 0, 0, 0, 0, 0, 0) ;
	wrefresh (bwp) ;

/*	pwp = newwin (12, 12, 1, 67) ;	*/
	pwp = newwin (PW_HEI, PW_WID, PW_LIN, PW_COL) ;
	wborder (pwp, 0, 0, 0, 0, 0, 0, 0, 0) ;
	wrefresh (pwp) ;

	if (copyflag) {
		/* xwp = newwin (6, 12, 13, 67) ; */
		xwp = newwin (6, XW_WID, XW_LIN, XW_COL) ;
		mvwprintw (xwp, 1, 1, "%s %s",  /* "read" */ "avg.", "speed") ;
		mvwprintw (xwp, 2, 1, "%s ", "in ") ;
		mvwprintw (xwp, 3, 1, "%s ", "out") ;
		mvwprintw (xwp, 4, 1, "%s ", "i/o") ;
	} else {
		if ( sectflag ) {
			/* xwp = newwin (4, 12, 13, 67) ; */
			xwp = newwin (4, XW_WID, XW_LIN, XW_COL) ;
			mvwprintw (xwp, 1, 1, "%s  %s", /* "seek" */ "avg.", "time") ;
		} else {
			/* xwp = newwin (6, 12, 13, 67) ; */
			xwp = newwin (6, XW_WID, XW_LIN, XW_COL) ;
			mvwprintw (xwp, 1, 1, "%s  %s", /* "read" */ "avg.", "time") ;
			mvwprintw (xwp, 3, 1, "%s %s",  /* "read" */ "avg.", "speed") ;
		}
	}
	wborder (xwp, 0, 0, 0, 0, 0, 0, 0, 0) ;
	wrefresh (xwp) ;

/*	swp = newwin (4, 66, 19, 1) ;	*/
	swp = newwin (SW_HEI, SW_WID, SW_LIN, SW_COL) ;
	wborder (swp, 0, 0, 0, 0, 0, 0, 0, 0) ;
	wrefresh (swp) ;

/*	iwp = newwin (4, 12, 19, 67) ;	*/
	iwp = newwin (IW_HEI, IW_WID, IW_LIN, IW_COL) ;
	wborder (iwp, 0, 0, 0, 0, 0, 0, 0, 0) ;
	wrefresh (iwp) ;

	wmove (swp, 1, 1) ; waddnstr (swp, readfilename, SW_WID-2) ;
	wmove (swp, 2, 1) ;
	if ( percflag ) {
		wprintw (swp, "%d%% ", ( flipflag ? 100 - usedperc : usedperc ) ) ;
		if ( strpflag ) {
			if ( flipflag )
				wprintw (swp, "(%dx%s) ", skipcnt , (char *) lltokmgtpe ( (long long) skipsize ) ) ;
			else
				wprintw (swp, "(%dx%s) ", stripcnt , (char *) lltokmgtpe ( (long long) strpsize ) ) ;
		}
		if ( headflag || tailflag || coreflag || edgeflag || slabflag )
			wprintw (swp, "(%s) ", getvdarea()) ;
		wprintw (swp, "of ") ;
	}
	wprintw (swp, "%s", (char *) lltokmgtpe ((long long)testsize)) ;
	wrefresh (swp) ;

	/* preset vis.blk entries */

	visblkcnt = 0 ;
	brow = bcol = 1 ;
	moresize = testsize ;
	lastpercok = -1 ;

	while ( moresize > 0 ) {

		if ( visblklst == NULL ) {
			visblklst = (VISBLKDAT *) malloc (VISBLKDATSIZ) ;
		} else {
			visblklst = (VISBLKDAT *) realloc (visblklst, (visblkcnt+1)*VISBLKDATSIZ) ;
		}

		if ( visblklst == NULL )
			vdtend (errno) ;

		lbp = visblklst + visblkcnt ;
		lbp->vbd_addr = visblkcnt * visblksiz ;
		worksize = testsize - moresize ;

		if ( percflag || strpflag ) {
			lbp->vbd_flags = flipflag ? VBF_USEFUL : 0 ;
		} else {
			lbp->vbd_flags = VBF_USEFUL ;
		}

		if ( percflag ) {
			if ( headflag && ( worksize <= headsize ) ) {
				lbp->vbd_flags = flipflag ? 0 : VBF_USEFUL ;
			}
			if ( tailflag && ( worksize >= tailsize ) ) {
				lbp->vbd_flags = flipflag ? 0 : VBF_USEFUL ;
			}
			if ( coreflag && ( worksize >= corehead && worksize <= coretail ) ) {
				lbp->vbd_flags = flipflag ? 0 : VBF_USEFUL ;
			}
		}

		if ( strpflag ) {
			for ( stripinx = 0 ; stripinx < stripcnt ; ++stripinx ) {
				if ( worksize >= strpbase[stripinx] && worksize <= ( strpbase[stripinx] + strpsize ) ) {
					lbp->vbd_flags = flipflag ? 0 : VBF_USEFUL ;
					break ;
				}
			}
		}

		percok = ( moresize * 100 ) / testsize ;
		if ( percok != lastpercok ) {
			percy = ( 10 * percok ) / 100 ;
			if ( percy ) {
				mvwprintw (pwp, 11-percy, 1, "%3d %% %s", percok, (char *) lltokmgtpe (moresize?moresize:1)) ;
				wrefresh (pwp) ;
				lastpercok = percok ;
			}
		}

		if ( moresize >= visblksiz ) {
			lbp->vbd_size = visblksiz ;
			moresize -= visblksiz ;
		} else {
			lbp->vbd_size = moresize ;
			moresize = 0 ;
		}

		if ( bcol > avcols ) {
			bcol = 1 ;
			++brow ;
		}

		lbp->vbd_lin  = brow ;
		lbp->vbd_col  = bcol++ ;
		lbp->vbd_hits = 0 ;

		mvwaddch (bwp, lbp->vbd_lin, lbp->vbd_col, lbp->vbd_flags & VBF_USEFUL ? '.' : skipchar) ;
		wrefresh (bwp) ;

		++visblkcnt ;
	}

	if ( lbp->vbd_size == visblksiz ) {
		wprintw (swp, "(%ld x %s) ", (long) visblkcnt, (char *) ltokmg (visblksiz)) ;
		totvisblk = visblkcnt ;
		lastsize = 0 ;
	} else {
		wprintw (swp, "(%ld x %s ", (long) (visblkcnt-1), (char *) ltokmg (visblksiz)) ;
		wprintw (swp, "+ %s) ", (char *) ltokmg (lbp->vbd_size)) ;
		totvisblk = visblkcnt - 1 ;
		lastsize = lbp->vbd_size ;
	}

	wrefresh (swp) ;

	if ( incrflag )
		vdtest ( VDT_INCR ) ;
	if ( decrflag )
		vdtest ( VDT_DECR ) ;
	if ( scatflag )
		vdtest ( VDT_SCAT ) ;
	if ( convflag )
		vdtest ( VDT_CONV ) ;
	if ( spotflag )
		vdtest ( VDT_SPOT ) ;
	if ( goldflag )
		vdtest ( VDT_GOLD ) ;
	if ( randflag )
		vdtest ( VDT_RAND ) ;
}

/*	__	__	__	__	__	__	__	__	*/

void vdt () {

	vdtinit () ;

	vdtmain () ;

	vdtend (0) ;
}

/*	__	__	__	__	__	__	__	__	*/

int main (argc, argv) int argc ; char * * argv ; {

	if (--argc) {
		while (*++argv) {
			if ( strcmp (*argv, "-?") == 0 ) {
				++helpflag ;
			} else if ( strcmp (*argv, "--help") == 0 ) {
				++helpflag ;
			} else if ( strcmp (*argv, "--decr") == 0 ) {
				++decrflag ;
			} else if ( strcmp (*argv, "--conv") == 0 ) {
				++convflag ;
			} else if ( strcmp (*argv, "--gold") == 0 ) {
				++goldflag ;
			} else if ( strcmp (*argv, "--read") == 0 ) {
				++readflag ;
			} else if ( strcmp (*argv, "--once") == 0 ) {
				++uniqflag ;
			} else if ( strcmp (*argv, "--uniq") == 0 ) {
				++uniqflag ;
			} else if ( strcmp (*argv, "--full") == 0 ) {
				++fullflag ;
			} else if ( strcmp (*argv, "--rand") == 0 ) {
				++randflag ;
			} else if ( strcmp (*argv, "--scat") == 0 ) {
				++scatflag ;
			} else if ( strcmp (*argv, "--incr") == 0 ) {
				++incrflag ;
			} else if ( strcmp (*argv, "--spot") == 0 ) {
				++spotflag ;
			} else if ( strcmp (*argv, "--head") == 0 ) {
				++headflag ;
			} else if ( strcmp (*argv, "--core") == 0 ) {
				++coreflag ;
			} else if ( strcmp (*argv, "--edge") == 0 ) {
				++edgeflag ;
			} else if ( strcmp (*argv, "--tail") == 0 ) {
				++tailflag ;
			} else if ( strcmp (*argv, "--slab") == 0 ) {
				++slabflag ;
			} else if ( strcmp (*argv, "--even") == 0 ) {
				++evenflag ;
			} else if ( strcmp (*argv, "--flip") == 0 ) {
				++flipflag ;
			} else if ( strcmp (*argv, "--sect") == 0 ) {
				++sectflag ;
			} else if ( strcmp (*argv, "--seek") == 0 ) {
				++seekflag ;
			} else if ( strcmp (*argv, "--wait") == 0 ) {
				++waitflag ;
			} else if ( strcmp (*argv, "--fill") == 0 ) {
				++fillflag ;
			} else if ( strcmp (*argv, "--burn") == 0 ) {
				++burnflag ;
			} else if ( strcmp (*argv, "--cook") == 0 ) {
				++cookflag ;
			} else if ( strcmp (*argv, "--writ") == 0 ) {
				++writflag ;
			} else if ( strcmp (*argv, "--copy") == 0 ) {
				++copyflag ;
			} else if ( strcmp (*argv, "--blot") == 0 ) {
				++blotflag ;
			} else if ( strcmp (*argv, "--mess") == 0 ) {
				++messflag ;
			} else if ( strcmp (*argv, "--cool") == 0 ) {
				++coolflag ;
			} else if ( strcmp (*argv, "--aver") == 0 ) {
				++averflag ;
			} else if ( strcmp (*argv, "--comp") == 0 ) {
				++compflag ;
			} else if ( strcmp (*argv, "--sync") == 0 ) {
				++syncflag ;
			} else if ( strcmp (*argv, "-z") == 0 ) {
# ifdef RAWSIZE
				sscanf ( *++argv , "%lld" , &declsize ) ;
# else
				declsize = bunitz ( *++argv ) ;
# endif
			} else if ( strcmp (*argv, "-b") == 0 ) {
				altbufsiz = (size_t) bunitz ( *++argv ) ;
			} else if ( strcmp (*argv, "-r") == 0 ) {
				readfilename = strdup ( *++argv ) ;
			} else if ( strcmp (*argv, "-w") == 0 ) {
				writfilename = strdup ( *++argv ) ;
			} else if ( strcmp (*argv, "-f") == 0 ) {
				rwiofilename = strdup ( *++argv ) ;
			} else if ( strcmp (*argv, "-l") == 0 ) {
				sscanf ( *++argv , "%d" , &avrows ) ;
			} else if ( strcmp (*argv, "-c") == 0 ) {
				sscanf ( *++argv , "%d" , &avcols ) ;
			} else if ( strcmp (*argv, "-p") == 0 ) {
				++percflag ;
				sscanf ( *++argv , "%d" , &declperc ) ;
			} else if ( strcmp (*argv, "-s") == 0 ) {
				++strpflag ;
				sscanf ( *++argv , "%d" , &stripcnt ) ;
			} else if ( strcmp (*argv, "-v") == 0 ) {
				++verbflag ;
			} else if ( strcmp (*argv, "-B") == 0 ) {
				skipchar = ' ' ;
			} else {
				++helpflag ;
			}
		}
	}

	vdt () ;

	return 0 ;
}

/*	__	__	__	__	__	__	__	__	*/

/*
 * vi:nu ts=4
 */
